import java.util.ArrayList;
import java.util.Scanner;


public class Main {
	public static void main(String[] argv) {
		ProductsDB db = new ProductsDB("/tmp/ordersdb.sqlite");
		if (db.isOpen()) {
			start(db);
			db.close();
		}
	}
	public static void start(ProductsDB db) {
		boolean stop = false;
		Scanner in = new Scanner(System.in);
		System.out.println("Enter your commands (help for help):");
		while(!stop)
		{
			System.out.print("> ");
			if(!in.hasNext()) in = new Scanner(System.in); String line = in.nextLine();
			String[] array = line.split(" ");
			int length = array.length;
			if (length>0) {
				String command = array[0];
				if(command.equals("help"))	{
					printHelp();
				} else if(command.equals("add") && length == 4) {
					addProduct(db, array[1], array[2], array[3]);
				} else if(command.equals("print") && length == 1) {
					printProducts(db);
				} else if(command.equals("quit")) {
					stop = true;
				} else {
					printError();
				}
			}
		}
	}
	private static void printError() {
		System.out.println("Incorrect syntax. Please try again. (type \"help\" for instructions).");
	}
	private static void printProducts(ProductsDB db) {
		ArrayList<String> rows = db.allRows();
		for (String s : rows) {
			System.out.println(s);
		}
	}
	private static void addProduct(ProductsDB db, String name,
			String size, String price) {
		int s, p;
		try {
			s = Integer.parseInt(size);
			p = Integer.parseInt(price);
		} catch (NumberFormatException e) {
			printError();
			return;
		}
		db.insert(name, s, p);
	}
	private static void printHelp() {
		System.out.println(
				"Available commands :\n"
				+" help		Prints this help message.\n"
				+" quit		Exits the program.\n"
				+" add		Adds a new entry to the database. Requires a name (single word) and two integers, separated by spaces.\n"
				+" print	Prints the entrie content of the database.\n");
	}
}