import java.io.File;
import java.util.ArrayList;

import com.almworks.sqlite4java.SQLiteConnection;
import com.almworks.sqlite4java.SQLiteException;
import com.almworks.sqlite4java.SQLiteStatement;


public class ProductsDB {
	SQLiteConnection db;
	public ProductsDB(String filename) {
		File f = new File(filename);
		boolean prev = f.exists();
		db = new SQLiteConnection(f);
		try {
			db.open(true);
		} catch (SQLiteException e) {
			db = null;
		}
		if (isOpen() && !prev) {
			initializeDB();
		}
	}
	public boolean isOpen() {
		return db != null;
	}
	private void initializeDB() {
		try {
			db.exec("CREATE TABLE products(id INTEGER PRIMARY KEY,"
				+ "name TEXT, size INTEGER, price INTEGER);");
			db.exec("INSERT INTO products(name, size, price) "
					+ "VALUES('car', 3, 18)");
		}
		catch (SQLiteException e) {
			e.printStackTrace();
		}
	}
	public ArrayList<String> allRows() {
		ArrayList<String> sl = new ArrayList<String>();
		if (isOpen()) {
			try {
				SQLiteStatement st = db.prepare("SELECT id, name, size, price FROM products;");
				int colnum = st.columnCount();
				String s = "";
				for (int i = 0; i < colnum; i++) {
					s += String.format("| %10s ", st.getColumnName(i)); 
				}
				sl.add(s + "|");
				while (st.step()) {
					s = "";
					for (int i = 0; i < colnum; i++) {
						s += String.format("| %10s ", st.columnValue(i).toString()); 
					}
					sl.add(s + "|");
				}
				return sl;
			} catch (SQLiteException e) {
				return sl;
			}
		} else {
			return sl;
		}
	}
	public void close() {
		if(isOpen()) {
			db.dispose();
		}
	}
	public void insert(String name, int size, int price) {
			try {
				SQLiteStatement st = db.prepare("INSERT INTO products(name, size, price) VALUES(?,?,?)");
				st.bind(1,  name);
				st.bind(2, size);
				st.bind(3, price);
				st.stepThrough();
			} catch (SQLiteException e) {
				System.out.println("Error: could not add item to db.");
			}
	}
}
